/*-----------------------------------------------------------------------                                                                                                                               
SAS Version : Ver.9.1.3  
 
codapath    : indext@CAoutputt@Cǂݍ݃pX
prefix      : BUGSR[hŐݒ肵t@C
             i_ SASvO3.3 #15Ŏw肵t@Cj
outcoda     : WinBUGSŐꂽeJW{i[SASf[^Zbg
outstats    : p[^̗v񓝌vʂZoSASf[^Zbgiw肵ꍇɎZoj
outnums     : outputt@C̐w
outgraph    : qXgO𐶐ioutgraph=Y̏ꍇɏój 
-----------------------------------------------------------------------*/

%macro codatrans(codapath=, prefix=, outcoda=, outstats=, outnums=1, outgraph=N);

  *outputt@C̃t@CQƖ ݒ;
  filename in ( %do i=1 %to &outnums ;
                  "&codapath\&prefix.&i..txt" 
                %end;
              );

  *outputt@CSASf[^Zbg; 
  data sasout;
    infile in dlm='09'x end=eof;
    do until(eof);
      input number value;
      output;
    end;
  run;  

  *indext@CSASf[^Zbg;
  data parameter;
    length parameter $100;
    infile "&codapath\&prefix.index.txt" dlm='09'x end=eof;
    do until(eof);
      input parameter $ firstnum lastnum;
      prm=lowcase(translate(parameter, "_ ", "[]"));
      prm_grp=lowcase(scan(parameter, 1, "["));
      if index(parameter, "[") > 0 then prm_seq=input(scan(parameter, 2, "[]"), best.);
      else prm_seq=1;
      output;
    end;
  run;
  
  *indext@C̒l}NϐɊi[;
  proc sql noprint;
    select count(prm) into :vnmcnt from parameter;
    select parameter into :lbl_1-:lbl_%trim(&vnmcnt) from parameter; *Otxp;
    select prm into :vnm_1-:vnm_%trim(&vnmcnt) from parameter;       *ϐ}NϐɊi[;

    select count(firstnum) into :fstcnt from parameter;
    select firstnum into :fst_1-:fst_%trim(&fstcnt) from parameter;  *Jnԍ}NϐɊi[;

    select count(lastnum) into :lstcnt from parameter;
    select lastnum into :lst_1-:lst_%trim(&lstcnt) from parameter;   *Iԍ}NϐɊi[;
  quit;

  *outputt@C̒lHioutput̐Loopj;
  %let lstnm= %left(&vnmcnt);

  %do j=1 %to &outnums;
    data _&outcoda._&j;
      merge %do i=1 %to &vnmcnt;
              sasout(firstobs=%eval(&&lst_&lstnm * (&j-1) + &&fst_&i) 
                          obs=%eval(&&lst_&lstnm * (&j-1) + &&lst_&i) 
                       rename=(value=&&vnm_&i))
            %end;
            ;
    run;
  %end;

  *Hf[^1f[^ZbgɌ;
  data &outcoda;
    set %do j=1 %to &outnums;
          _&outcoda._&j
        %end;
        ;
  run;
  
  *v񓝌vʂ̎Zo;
  %if &outstats ^= %then %do;
    %do i=1 %to &vnmcnt;
      proc univariate noprint data=&outcoda;
        var &&vnm_&i;
        %if %upcase(&outgraph) = Y %then %do; 
          histogram &&vnm_&i / kernel; 
        %end;
        output out=_stats_&i n=n mean=mean var=var std=std min=min max=max
                             range=range pctlpts=10 median=median pctlpts=90
                             kurtosis=kurtosis skewness=skewness pctlpre=p;
        label &&vnm_&i="&&lbl_&i";
      run;
      
      *v񓝌vʂɂ郉x}NϐɊi[;
      %if &i=1 %then %do;
        proc contents data=_stats_&i out=_con noprint;
        run;

        data _con;
          set _con;
          _label=left(kscan(label, 2, ""));
        run;

        proc sql noprint;
          select count(name) into :statsvnmcnt from _con;
          select name into :statsvnm_1-:statsvnm_%trim(&statsvnmcnt) from _con;
          select _label into :statslbl_1-:statslbl_%trim(&statsvnmcnt) from _con;
        quit;
      %end;
    %end;  

    *v񓝌vʂ1f[^ZbgɌ;
    data &outstats;
      set %do i=1 %to &vnmcnt;
            _stats_&i
          %end;
          ;
      *v񓝌vʃx̕t^;
      %do i=1 %to &statsvnmcnt;
        label &&statsvnm_&i="&&statslbl_&i";
      %end;
    run;
    
    *v񓝌vʂɃp[^;
    data &outstats;
      set parameter(keep=parameter prm_grp prm_seq);
      set &outstats;
    run;
  %end;  

  *workf[^̍폜;
  proc datasets nolist;
    delete _&outcoda: _stats: sasout _con parameter;
  run ;
  quit;  

%mend codatrans;
